"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUnsignedAddDelegator = exports.addDelegator = void 0;
const dist_1 = require("@flarenetwork/flarejs/dist");
const utils_1 = require("@flarenetwork/flarejs/dist/utils");
const utils_2 = require("./utils");
function addDelegator(ctx, nodeID, stakeAmount, startTime, endTime) {
    return __awaiter(this, void 0, void 0, function* () {
        const threshold = 1;
        const locktime = new dist_1.BN(0);
        const asOf = (0, utils_1.UnixNow)();
        const platformVMUTXOResponse = yield ctx.pchain.getUTXOs(ctx.pAddressBech32);
        const utxoSet = platformVMUTXOResponse.utxos;
        const unsignedTx = yield ctx.pchain.buildAddDelegatorTx(utxoSet, [ctx.pAddressBech32], [ctx.pAddressBech32], [ctx.pAddressBech32], nodeID, startTime, endTime, stakeAmount, [ctx.pAddressBech32], locktime, threshold, undefined, asOf);
        const tx = unsignedTx.sign(ctx.pKeychain);
        const txid = yield ctx.pchain.issueTx(tx);
        return { txid: txid };
    });
}
exports.addDelegator = addDelegator;
function getUnsignedAddDelegator(ctx, nodeID, stakeAmount, startTime, endTime) {
    return __awaiter(this, void 0, void 0, function* () {
        const threshold = 1;
        const locktime = new dist_1.BN(0);
        const asOf = (0, utils_1.UnixNow)();
        const platformVMUTXOResponse = yield ctx.pchain.getUTXOs(ctx.pAddressBech32);
        const utxoSet = platformVMUTXOResponse.utxos;
        const unsignedTx = yield ctx.pchain.buildAddDelegatorTx(utxoSet, [ctx.pAddressBech32], [ctx.pAddressBech32], [ctx.pAddressBech32], nodeID, startTime, endTime, stakeAmount, [ctx.pAddressBech32], locktime, threshold, undefined, asOf);
        return {
            serialization: (0, utils_2.serializeUnsignedTx)(unsignedTx),
            signatureRequests: unsignedTx.prepareUnsignedHashes(ctx.cKeychain),
            unsignedTransactionBuffer: unsignedTx.toBuffer().toString('hex')
        };
    });
}
exports.getUnsignedAddDelegator = getUnsignedAddDelegator;
